<template>
  <article class="cart-card py-3" v-if="product">
    <div>
      <img :src="product.foto_real.url" :alt="product.name" class="w-100 h-100" v-if="product.foto_real" />
    </div>

    <section class="card-content p-2">
      <h3 class="name">{{ product.name }}</h3>

      <div
        class="delete-container d-flex justify-content-end align-items-start"
      >
        <button class="btn-delete bg-transparent border-0" @click="removeProduct(index)">
          <i class="fas fa-trash-alt" aria-hidden="true"></i>
        </button>
      </div>

      <div class="price-container">
        <section class="price d-flex">
          <div class="with-offer" v-if="product.precio_descuento">
            <h3 class="real my-0">{{ price(product.precio_real) }}</h3>
            <h3 class="offer my-0">{{ price(product.precio_descuento) }}</h3>
          </div>
          <div v-else>
            <h3 class="offer my-0">{{ price(product.precio_real) }}</h3>
          </div>
        </section>
      </div>

      <div class="controls-container">
        <Controls :product="product" :index="index" />
      </div>
    </section>
  </article>
</template>

<script>
import { priceFormat } from '@/utils/price-format.js'

import Controls from "./Controls.vue";

export default {
  components: {
    Controls,
  },
  props: {
    product: Object,
    index: Number
  },
  methods: {
    price(val) {
      return priceFormat(val)
    },
    removeProduct(index) {
      this.$store.commit('cart/REMOVE_PRODUCT', index)
    }
  }
};
</script>

<style lang="scss" scoped>
@import "~/assets/scss/variables";

.cart-card {
  display: grid;
  grid-template-columns: 30% 70%;

  @media (min-width: 420px) {
    grid-template-columns: 35% 65%;
  }

  @media (min-width: 768px) {
    grid-template-columns: 25% 75%;
  }

  .card-content {
    display: grid;
    grid-template-columns: 1fr 1fr 1fr;
    grid-template-rows: auto auto;
  }

  .name {
    grid-column: 1 / 3;
    grid-row: 1 / 2;
    font-size: .7em;

    @media (min-width: 420px) {
      font-size: 0.9em;
    }
  }

  .delete-container {
    grid-column: 3 / 4;
  }

  .price-container {
    grid-column: 1 / 3;
    grid-row: 2 / 3;
  }

  .price {
    height: 40px;

    .with-offer {
      .real {
        font-size: 0.8em;
        color: rgba($dark, 0.8);
        text-decoration: line-through;
      }
    }

    h3 {
      font-size: 1.1em;
      font-weight: 700;
      margin: 0;
    }

    .offer {
      color: $primary;
    }
  }

  .controls-container {
    grid-column: 3 / 4;
    grid-row: 2 / 3;
    width: 120px;
  }

  .btn-delete {
    color: rgba($secondary, 0.5);
    transition: color 1s;

    &:hover {
      color: rgba($secondary, .8);
    }
  }
}
</style>